package dao

import (
	"gorm.io/gorm"
	"hilo/app/service/user/internal/model"
)

func (d *Dao) GetGroupInfo(groupId string) (*model.GroupInfo, error) {
	r := &model.GroupInfo{}
	err := d.DB.Where(&model.GroupInfo{ImGroupId: groupId}).First(r).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return r, nil
}

func (d *Dao) GetGroupPowerUser(userId int64) (*model.GroupPowerUser, error) {
	groupPowerUser := &model.GroupPowerUser{}
	err := d.DB.Where(&model.GroupPowerUser{UserId: userId}).First(groupPowerUser).Error
	if err != nil && err != gorm.ErrRecordNotFound {
		return nil, err
	}
	return groupPowerUser, nil
}

func (d *Dao) GetGroupPower(id int64) (*model.GroupPower, error) {
	groupPower := &model.GroupPower{}
	if err := d.DB.Model(&model.GroupPower{}).First(groupPower, id).Error; err != nil {
		return nil, err
	}
	return groupPower, nil
}
