package handler

import (
	"context"
	"hilo/api/service/user"
	"hilo/app/service/user/internal/service"
)

type UserService struct {
	user.UnimplementedUserServer
	svc *service.UserService
}

func (s *UserService) Login(ctx context.Context, req *user.LoginReq) (*user.LoginRep, error) {
	res, err := s.svc.Login(ctx, req)
	if err != nil {
		return nil, err
	}
	return res, nil
}

var _ user.UserServer = &UserService{}

func NewUserHandler(svc *service.UserService) *UserService {
	return &UserService{svc: svc}
}
